﻿/*
 * Access.cs
 * 
 * whale - win32 attack surface toolkit
 * 
 * Jeremy Brown / Dec 2016
 * jbrown3264/gmail
 * 
 */

using System;
using System.IO.Pipes;
using System.Security.AccessControl;

namespace whale
{
    class Access
    {
        public static String GetSDDLPipe(String pipe)
        {
            String sddlString = null;

            PipeSecurity pipeSecurity = new PipeSecurity();

            //Console.WriteLine("Getting SDDL for \\\\.\\pipe\\{0}...\n", pipe);

            NamedPipeClientStream stream = null;
            try
            {
                String namedPipe = pipe.Split(new[] {"\\\\.\\pipe\\"}, StringSplitOptions.None)[1];
                stream = new NamedPipeClientStream(".", namedPipe, PipeDirection.In, PipeOptions.None);
            }
            catch (Exception error)
            {
                Console.WriteLine("Error: {0}", error.Message);
                return null;
            }

            try
            {
                stream.Connect(5000);
            }
            catch (Exception error)
            {
                Console.WriteLine("Error: {0}", error.Message);
                return null;
            }

            if (stream.IsConnected)
            {
                pipeSecurity = stream.GetAccessControl();

                if (pipeSecurity != null)
                {
                    //Console.WriteLine("Owner: {0}", pipeSecurity.GetOwner(typeof(NTAccount)));
                    //Console.WriteLine("Group: {0}\n", pipeSecurity.GetGroup(typeof(NTAccount)));
                    //Console.WriteLine("{0}\n", pipeSecurity.GetSecurityDescriptorSddlForm(AccessControlSections.All));

                    sddlString = pipeSecurity.GetSecurityDescriptorSddlForm(AccessControlSections.All);
                }
            }

            stream.Close();
            
            return sddlString;
        }

        


        //
        // Reference: http://csharptest.net/1043/how-to-prevent-users-from-killing-your-service-process/index.html
        //
        // Only works in win32 names
        //
        //public static String GetSDDLGeneric(String objectPath)
        //{
        //    String sddlString = null;
        //    const int DACL_SECURITY_INFORMATION = 0x00000004;
        //    byte[] pSecurityDescriptor = new byte[0];
        //    uint bufSizeNeeded;

        //    IntPtr handle = Native.CreateFile(objectPath, FileAccess.Read, FileShare.None, IntPtr.Zero, FileMode.Open, 0, IntPtr.Zero);

        //    if (handle.ToInt32() < 0)
        //    {
        //        throw new Win32Exception();
        //    }

        //    Native.GetKernelObjectSecurity(handle, DACL_SECURITY_INFORMATION, pSecurityDescriptor, 0, out bufSizeNeeded);

        //    if (bufSizeNeeded < 0 || bufSizeNeeded > short.MaxValue)
        //    {
        //        throw new Win32Exception();
        //    }

        //    if (!Native.GetKernelObjectSecurity(handle, DACL_SECURITY_INFORMATION, pSecurityDescriptor = new byte[bufSizeNeeded], bufSizeNeeded, out bufSizeNeeded))
        //    {
        //        throw new Win32Exception();
        //    }

        //    if (pSecurityDescriptor.Length > 0)
        //    {
        //        sddlString = new RawSecurityDescriptor(pSecurityDescriptor, 0).GetSddlForm(AccessControlSections.All);
        //    }
            
        //    return sddlString;
        //}
    }
}
