﻿/*
 * Misc.cs
 * 
 * whale - win32 attack surface toolkit
 * 
 * Jeremy Brown / Dec 2016
 * jbrown3264/gmail
 * 
 */

using System;
using System.Collections.Generic;
using System.Linq;

namespace whale
{
    class Misc
    {
        public static String SDDLtoText(String sddlString)
        {
            String sddlText = null;

            sddlText = SDDLParser.Parse(sddlString);

            return sddlText;
        }


        public static void DiffObjectList(List<Objects> current, List<Objects> previous, String surface)
        {
            List<String> currentName = current.Select(item => item.Name).ToList();
            List<String> previousName = previous.Select(item => item.Name).ToList();

            var difference = currentName.Except(previousName).ToList();

            if (difference.Any())
            {
                if (difference[0].Length > 2)
                {
                    Console.WriteLine("\n[NEW] {0}:\n", surface);

                    foreach (var result in difference)
                    {
                        Console.WriteLine("{0}", result);
                    }
                }
                
            }

            difference = previousName.Except(currentName).ToList();

            if (difference.Any())
            {
                if (difference[0].Length > 2)
                {
                    Console.WriteLine("\n[DELETED] {0}:\n", surface);

                    foreach (var result in difference)
                    {
                        Console.WriteLine("{0}", result);
                    }
                }
                
            }
        }

        public static void DiffList(List<String> current, List<String> previous, String surface)
        {
            var difference = current.Except(previous).ToList();

            if (difference.Any())
            {
                Console.WriteLine("\n[NEW] {0}:\n", surface);

                foreach (var result in difference)
                {
                    Console.WriteLine("{0}", result);
                }
            }

            difference = previous.Except(current).ToList();
            
            if (difference.Any())
            {
                Console.WriteLine("\n[DELETED] {0}:\n", surface);

                foreach (var result in difference)
                {
                    Console.WriteLine("{0}", result);
                }
            }
        }
    }
}
