﻿/*
 * Program.cs
 * 
 * whale - win32 attack surface toolkit
 * 
 * Jeremy Brown / Dec 2016
 * jbrown3264/gmail
 * 
 */

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Threading;

namespace whale
{
    class Program
    {
        public const string DEVICE_LOC = "\\Device";
        public const string ALPC_LOC = "\\RPC Control";
        public const string DRIVER_LOC = "\\Driver";
        public const string BNO_LOC = "\\BaseNamedObjects";


        static int Main(string[] args)
        {
            Console.WriteLine("Whale...\n");

            if (!args.Any())
            {
                Options();
                return 0;
            }

            String action = args[0];
            String objectX = String.Empty;

            if (args.Count() >= 2)
            {
                objectX = args[1];
            }

            //
            // get and hold a mutex handle
            //
            if (action.Equals("hold"))
            {
                if (!objectX.Any())
                {
                    Console.WriteLine("Error: please provide a name to hold");
                    return -1;
                }

                Mutant.Hold(objectX);

                return 0;
            }

            //
            // get and hold a mutex handle in a loop
            //
            if (action.Equals("race"))
            {
                if (!objectX.Any())
                {
                    Console.WriteLine("Error: please provide a name for the race");
                    return -1;
                }

                Mutant.Race(objectX);

                return 0;
            }

            //
            // create a mutex that RDP replies on to be available in order to create new sessions
            //
            if (action.Equals("delayrdp"))
            {
                Mutant.DelayRdp();

                return 0;
            }

            //
            // run accesschk to find interesting stuff.. a bag of tricks
            //
            // References:
            //
            // https://media.blackhat.com/bh-us-11/Cerrudo/BH_US_11_Cerrudo_Vulnerability_Hunting_Windows_Slides.pdf
            // 
            //
            if (action.Equals("tricks"))
            {
                String accesschkExe = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location) + "\\accesschk.exe";

                //
                // only run if accesschk.exe is present in the local directory
                //
                if (!File.Exists(accesschkExe))
                {
                    Console.WriteLine("Error: did you drop accesschk in the local directory?");
                    return -1;
                }

                //
                // writable objects by everyone
                //
                Surface.Tricks(accesschkExe, "-uwo everyone " + DEVICE_LOC, "Devices writable by Everyone");

                //
                // processes with everyone acls
                //
                Surface.Tricks(accesschkExe, "-uwp * | findstr /i everyone", "Processes writable by Everyone");

                //
                // services/drivers with everyone acls
                //
                Surface.Tricks(accesschkExe, "-uwc * | findstr /i everyone", "Services writable by Everyone");

                //
                // processes with NULL dacls (findstr doesn't natively support multiline regex)
                //
                // For a NULL dacl, SE_DACL_PRESENT should not be set
                //
                // DESCRIPTOR FLAGS: <--
                // [SE_DACL_PRESENT] --- should not be here
                // [SE_SACL_PRESENT] -->
                // [SE_SACL_PROTECTED]
                //
                // therefore, we look for descriptor flags NOT being immediately followed by the dacl present flag
                // not foolproof, but more testing would figure this out
                //
                // Modified RxGrep to not be so noisy on output
                //Surface.Tricks(accesschkExe, "-upl * | RxGrep.exe \".*^(DESCRIPTOR(\\s+)FLAGS:(\\s+)\\[SE_DACL_PRESENT\\].*)", "Processes with NULL ACLs");

                //if (objectX.Equals("all"))
                //{
                //    //
                //    // writable files by users in core windows directory
                //    //
                //    Surface.Tricks(accesschkExe, "-uws users C:\\Windows", "Files writable by users");
                    
                //    //
                //    // writable registry keys by users in HKLM
                //    //
                //    Surface.Tricks(accesschkExe, "-ukws users HKLM", "Registry keys writable by users");
                //}

                return 0;
            }


            //
            // this doesn't work for everything.. but you can supplement it's shortcomings with other tools
            //
            if (action.Equals("view") && objectX.Any())
            {
                List<Objects> objectList = new List<Objects>();
                Surface.GetObjects(objectList, objectX);

                if (!objectList.Any())
                {
                    Console.WriteLine("No objects returned for path {0}", objectX);
                }

                foreach (var objects in objectList)
                {
                    Console.WriteLine("{0}", objects.Name);
                }

                return 0;
            }


            if (action.Equals("makepipe"))
            {
                if (!objectX.Any())
                {
                    Console.WriteLine("Error: please provide a pipe name");
                    return -1;
                }

                Pipe.Make(objectX);

                return 0;
            }


            if (action.Equals("killpipe"))
            {
                if (!objectX.Contains("pipe"))
                {
                    Console.WriteLine("Error: please provide the full pipe name");
                    return -1;
                }

                Pipe.Kill(objectX);

                return 0;
            }



            if (action.Equals("check") && objectX.Any())
            {
                String sddlString = null;
                String sddlText = null;

                if (objectX.Contains("pipe"))
                {
                    sddlString = Access.GetSDDLPipe(objectX);
                }
                else
                {
                    Console.WriteLine("Error: only pipes are supported, try accesschk for others");
                    return -1;
                }

                if (sddlString != null)
                {
                    sddlText = Misc.SDDLtoText(sddlString);
                }

                if (sddlText != null)
                {
                    Console.WriteLine("{0}\n\n{1}\n\n{2}", objectX, sddlString, sddlText);
                }

                return 0;
            }

            //
            // translate sddl string to human-consumable output
            //
            if (action.Equals("translate"))
            {
                if (!objectX.Any())
                {
                    Console.WriteLine("Error: please provide an SDDL string");
                    return -1;
                }

                String sddlText = null;

                sddlText = Misc.SDDLtoText(objectX);

                if (sddlText != null)
                {
                    Console.WriteLine("{0}\n\n{1}", objectX, sddlText);
                }
                else
                {
                    Console.WriteLine("Error: Couldn't parse sddl string \"{0}\"", objectX);
                    return -1;
                }

                return 0;
            }

            //
            // If we're doing a diff or watch, we need to prepare for such activities
            //

            //
            // network ports
            //
            List<Objects> portList = new List<Objects>();
            Surface.GetPorts(portList);

            //
            // processes
            //
            List<Objects> processList = new List<Objects>();
            Surface.GetProcesses(processList);

            //
            // services
            //
            List<Objects> serviceList = new List<Objects>();
            Surface.GetServices(serviceList);

            //
            // pipes
            //
            List<Objects> pipeList = new List<Objects>();
            Surface.GetPipes(pipeList);

            //
            // devices
            //
            List<Objects> deviceList = new List<Objects>();
            Surface.GetObjects(deviceList, DEVICE_LOC);

            //
            // alpc ports
            //
            List<Objects> alpcList = new List<Objects>();
            Surface.GetObjects(alpcList, ALPC_LOC);

            //
            // drivers
            //
            List<Objects> driverList = new List<Objects>();
            Surface.GetObjects(driverList, DRIVER_LOC);

            //
            // basenamedobjects
            //
            List<Objects> bnoList = new List<Objects>();
            Surface.GetObjects(bnoList, BNO_LOC);


            // Note:
            //
            // Without a more complex, less memory-intensive implementation of the watch feature, you probably don't
            // want to keep it continiously running for more than a day or so, else the eventual OutOfMemory exception.
            // (this is better implemented as a driver that hooks the object manager)
            //
            if (action.Equals("watch"))
            {
                while (true)
                {
                    if (!objectX.Any() || objectX.Equals("ports"))
                    {
                        List<Objects> portListNew = new List<Objects>();
                        Surface.GetPorts(portListNew);

                        Misc.DiffObjectList(portListNew, portList, "ports");

                        portList = portListNew;
                    }


                    if (!objectX.Any() || objectX.Equals("processes"))
                    {
                        List<Objects> processListNew = new List<Objects>();
                        Surface.GetProcesses(processListNew);

                        Misc.DiffObjectList(processListNew, processList, "processes");

                        processList = processListNew;
                    }

                    if (!objectX.Any() || objectX.Equals("services"))
                    {
                        List<Objects> serviceListNew = new List<Objects>();
                        Surface.GetServices(serviceListNew);

                        Misc.DiffObjectList(serviceListNew, serviceList, "services");

                        serviceList = serviceListNew;
                    }

                    if (!objectX.Any() || objectX.Equals("pipes"))
                    {
                        List<Objects> pipeListNew = new List<Objects>();
                        Surface.GetPipes(pipeListNew);

                        Misc.DiffObjectList(pipeListNew, pipeList, "pipes");

                        pipeList = pipeListNew;
                    }

                    if (!objectX.Any() || objectX.Equals("devices"))
                    {

                        List<Objects> deviceListNew = new List<Objects>();
                        Surface.GetObjects(deviceListNew, DEVICE_LOC);

                        Misc.DiffObjectList(deviceListNew, deviceList, "devices");

                        deviceList = deviceListNew;
                    }

                    if (!objectX.Any() || objectX.Equals("alpc"))
                    {
                        List<Objects> alpcListNew = new List<Objects>();
                        Surface.GetObjects(alpcListNew, ALPC_LOC);

                        Misc.DiffObjectList(alpcListNew, alpcList, "alpc");

                        alpcList = alpcListNew;
                    }

                    if (!objectX.Any() || objectX.Equals("drivers"))
                    {
                        List<Objects> driverListNew = new List<Objects>();
                        Surface.GetObjects(driverListNew, DRIVER_LOC);

                        Misc.DiffObjectList(driverListNew, driverList, "drivers");

                        driverList = driverListNew;
                    }

                    if (!objectX.Any() || objectX.Equals("bno"))
                    {
                        List<Objects> bnoListNew = new List<Objects>();
                        Surface.GetObjects(bnoListNew, BNO_LOC);

                        Misc.DiffObjectList(bnoListNew, bnoList, "bno");

                        bnoList = bnoListNew;
                    }

                    //
                    // help ease memory pressure
                    //
                    GC.Collect();
                    Thread.Sleep(20);
                }
            }

            return 0;
        }

        static void Options()
        {
            Console.WriteLine("Usage:   Whale.exe <action> [object]");
            Console.WriteLine("Actions: watch, view, check, translate, makepipe, killpipe, hold, ...\n");
            Console.WriteLine("Eg.      whale watch pipes");
            Console.WriteLine("         ..... view \\Device or service/CryptSvc");
            Console.WriteLine("         ..... check \\\\.\\pipe\\MSBuild1234");
            Console.WriteLine("         ..... translate \"D:(A;;0x1201bf;;;WD)\"");
            Console.WriteLine("         ..... makepipe \"Winsock2\\CatalogChangeListener-1100-3\"");
            Console.WriteLine("         ..... killpipe \\\\.\\pipe\\WiFiNetworkManagerTask");
            Console.WriteLine("         ..... hold _MSIExecute");
            Console.WriteLine("         ..... race msctf.serverWinlogon2");
            Console.WriteLine("         ..... delayrdp");
            Console.WriteLine("         ..... tricks");
        }
    }
}
