﻿/*
 * Surface.cs
 * 
 * whale - win32 attack surface toolkit
 * 
 * Jeremy Brown / Dec 2016
 * jbrown3264/gmail
 * 
 */

using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.InteropServices;
using System.IO;
using Microsoft.Win32.SafeHandles;
using System.ServiceProcess;

namespace whale
{
    class Surface
    {
        public static int GetPorts(List<Objects> objectList)
        {
            List<ProcessPort> processPortList = new List<ProcessPort>();
            try
            {
                processPortList = ProcessPorts.ProcessPortMap.ToList();
            }
            catch (Exception error)
            {
                return -1;
            }
            
            foreach (ProcessPort process in processPortList)
            {
                // not interested in Google chrome here as it's makes things super noisy, but if you are, remove this
                if (!process.ProcessName.Equals("chrome") && !process.ProcessName.Equals("Idle"))
                {
                    objectList.Add(new Objects(process.ProcessPortDescription, null));
                }
            }

            return 0;
        }

        public static int GetProcesses(List<Objects> objectList)
        {
            Process[] processList = Process.GetProcesses();

            foreach (Process process in processList)
            {
                objectList.Add(new Objects(process.ProcessName, null));
            }

            return 0;
        }

        public static int Tricks(String accesschkExe, String arguments, String description)
        {
            List<String> output = new List<String>();

            ProcessStartInfo processStartInfo = new ProcessStartInfo();
            processStartInfo.FileName = "cmd.exe";
            processStartInfo.Arguments = "/C " + accesschkExe + " " + arguments;
            processStartInfo.UseShellExecute = false;
            processStartInfo.RedirectStandardOutput = true;
            processStartInfo.CreateNoWindow = true;

            Process process = new Process();
            process.StartInfo = processStartInfo;

            process.OutputDataReceived += delegate(object sender, DataReceivedEventArgs args)
            {
                output.Add(args.Data);
            };

            try
            {
                process.Start();
                process.BeginOutputReadLine();
                process.WaitForExit();
                process.CancelOutputRead();
            }
            catch (Exception error)
            {
                Console.WriteLine("Error: {0}", error);
                return -1;
            }

            if (output.Any())
            {
                Console.WriteLine("{0}:\n", description);

                foreach (String line in output)
                {
                    Console.WriteLine("{0}", line);
                }
            }
            else
            {
                Console.WriteLine("{0}:\nNone", description);
            }

            return 0;
        }


        public static int GetServices(List<Objects> objectList)
        {
            ServiceController[] services = ServiceController.GetServices();

            foreach (var service in services)
            {
                //serviceList.Add(new Objects(service.ServiceName, Access.GetServiceSDDL(service)));
                objectList.Add(new Objects(service.ServiceName, null));
            }

            return 0;
        }

        public static int GetPipes(List<Objects> objectList)
        {
            const string PIPE_LOC = @"\\.\pipe\";
            List<String> pipes = new List<string>();

            try
            {
                pipes = Directory.GetFiles(PIPE_LOC).ToList();
            }
            catch (Exception error)
            {
                Console.WriteLine("Error: {0}", error);
                return -1;
            }

            foreach (var pipe in pipes)
            {
                //pipeList.Add(new Objects(pipe, Access.GetPipeSDDL(pipe)));

                //
                // filter out chrome browser stuff that we're not interested in
                //
                if (!pipe.Contains("mojo") && !pipe.Contains("crashpad"))
                {
                    objectList.Add(new Objects(pipe, null));
                }
            }

            return 0;
        }


        //
        // Reference: http://www.pinvoke.net/default.aspx/ntdll/NtOpenDirectoryObject.html
        //
        public static int GetObjects(List<Objects> objectList, String objectDirectory)
        {
            SafeFileHandle handle;
            int size = 1024, status;
            uint context = 0, len;

            var attributes = new Native.OBJECT_ATTRIBUTES(objectDirectory, 0);

            if ((status = Native.NtOpenDirectoryObject(out handle, 1, ref attributes)) < 0)
            {
                // todo: throw error message here
                return -1;
            }

            while(status >= 0)
            //for (;;)
            {
                var buffer = Marshal.AllocHGlobal(size);

                if((status = Native.NtQueryDirectoryObject(handle, buffer, size, true, context == 0, ref context, out len)) < 0)
                {
                    // todo: throw error message here
                    return -1;
                }

                var odi = (Native.OBJECT_DIRECTORY_INFORMATION)Marshal.PtrToStructure(buffer, typeof(Native.OBJECT_DIRECTORY_INFORMATION));

                //Console.WriteLine("{0} - {1}", odi.TypeName, odi.Name);
                //if (odi.TypeName.ToString() == "Device")
                //{
                //    list.Add(new Objects(odi.Name.ToString(), null));
                //}

                //
                // only add alpc ports if we're looking at RPC Control
                //
                if (objectDirectory.Contains("RPC"))
                {
                    if (odi.TypeName.ToString() == "ALPC Port")
                    {
                        //objectList.Add(new Objects(objectDirectory + "\\" + odi.Name, null));
                        objectList.Add(new Objects(odi.Name.ToString(), null));
                    }
                }
                else
                {
                    objectList.Add(new Objects(objectDirectory + "\\" + odi.Name, null));
                }

                Marshal.FreeHGlobal(buffer);
            }

            attributes.Dispose();

            return 0;
        }


    }
}
